UseCyct =	0	; better for P4 timings, requires include file
MisAlign =	9	; add MisAlign bytes to the src pointer
CrashIt =	0	; overrides MisAlign - some algos will bang their head against the VirtualAlloc boundary
ShowLingoBang = 0	; for CrashIt = 1, this option raises a nice exception
ShowShorts =	1	; show also timings for short strings
rct =	4	; repeat timings n times

.nolist
include \masm32\include\masm32rt.inc
.686
.xmm

LOOP_COUNT	= 1000000
if UseCyct
	include \masm32\MasmBasic\Cyct_Macros.inc	; [url=\masm32\MasmBasic\Cyct_Macros.inc]open[/url]
else
	include \masm32\macros\timers.asm
endif

a16 MACRO
	align 16
	REPEAT 16
		retn 0		; tell the CPU there is nothing interesting before the proc
	ENDM
ENDM

cycles MACRO src, algo, extra
  if UseCyct
	cyct_begin
		push &src
		call &algo
	cyct_end <&algo&>
  else
	invoke Sleep, SleepMs
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push &src
		call &algo
	counter_end
	print str$(eax), 9, "cycles for &algo &extra", 13, 10
  endif
ENDM

CodeSize MACRO algo
LOCAL ct, tmp$
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&
  print str$(eax),9,"code size for &algo&",9
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s
  print str$(eax), 9, "total bytes for &algo&", 13, 10
  ife CrashIt
  push Src
  call algo
  .if eax!=Magic
	print str$(eax), " - ERROR for main string", 13, 10
  .endif
  ct=0
  REPEAT 20
  	ifidn <algo>,<AxStrLenSSE1>
  	;int 3
  	endif
  	ct=ct+1
  	tmp$ CATSTR <push offset src>, %ct
  	tmp$
  	call algo
	.if eax!=ct
		print str$(eax), " - ERROR in &algo&, ct="
		print str$(ct), 13, 10
	.endif
  ENDM
  endif
  popad
ENDM

.data
align 16
;ifndef CHECK_AS_ALIGNED
;	db 9 dup (0)
;endif
Magic = SIZEOF xSrc-1
if CrashIt
	xSrc	db 1 dup("Too short"), 0
else
	xSrc	db 1 dup("This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos."), 0
endif
db 5 dup (123)

Src	dd xSrc
vaPtr	dd 0
EspGlob	dd 0
align 16
; padding db 15 dup("x")
src1	db "1", 0, "xxxxxxxxxx", 0, 0, 0
src2	db "12", 0, "xxxxxxxxxx", 0, 0, 0
src3	db "123", 0, "xxxxxxxxxx", 0, 0, 0
src4	db "1234", 0, "xxxxxxxxxx", 0, 0, 0
src5	db "12345", 0, "xxxxxxxxxx", 0, 0, 0
src6	db "123456", 0, "xxxxxxxxxx", 0, 0, 0
src7	db "1234567", 0, "xxxxxxxxxx", 0, 0, 0
src8	db "12345678", 0, "xxxxxxxxxx", 0, 0, 0
src9	db "123456789", 0, "xxxxxxxxxx", 0, 0, 0
src10	db "1234567890", 0, "xxxxxxxxxx", 0, 0, 0
src11	db "12345678901", 0, "xxxxxxxxxx", 0, 0, 0
src12	db "123456789012", 0, "xxxxxxxxxx", 0, 0, 0
src13	db "1234567890123", 0, "xxxxxxxxxx", 0, 0, 0
src14	db "12345678901234", 0, "xxxxxxxxxx", 0, 0, 0
src15	db "123456789012345", 0, "xxxxxxxxxx", 0, 0, 0
src16	db "1234567890123456", 0, "xxxxxxxxxx", 0, 0, 0
src17	db "12345678901234567", 0, "xxxxxxxxxx", 0, 0, 0
src18	db "123456789012345678", 0, "xxxxxxxxxx", 0, 0, 0
src19	db "1234567890123456789", 0, "xxxxxxxxxx", 0, 0, 0
src20	db "12345678901234567890", 0, "xxxxxxxxxx", 0, 0, 0

.code
start:
	SleepMs = 20
	push 1
	call ShowCpu						; print brand string and SSE level
	mov Src, rv(VirtualAlloc, 0, 4096, MEM_COMMIT, PAGE_READWRITE)
	if CrashIt
		add Src, 4096-Magic-1				; go near the boundary
	elseif MisAlign
		add Src, MisAlign
	endif
	mov vaPtr, eax
	invoke lstrcpy, Src, offset xSrc
;	CodeSize MbStrLen1
;	CodeSize MbStrLen2
;	CodeSize MbStrLen3
;	CodeSize MbStrLen4a
;	CodeSize MbStrLen4aP4
;	CodeSize MbStrLen4aP42
;	CodeSize MbStrLen4b
;	CodeSize MbStrLen5
;	CodeSize AxStrLenMMX
	CodeSize AxStrLenSSE1
;	CodeSize AxJJStrLen1
;	CodeSize AxJJStrLen2
;	CodeSize AxJJStrLen3
	CodeSize AxJJStrLen4
	CodeSize AxJJStrLen5
;	CodeSize AxJJStrLen6
;	CodeSize StrLenLingo
;	CodeSize StrLen
	print chr$(13, 10)
	if CrashIt
		print chr$("------- timings, crash mode, 100 byte string -------", 13, 10)
	elseif MisAlign
		print chr$("------- timings, misaligned, 100 byte string -------", 13, 10)
	else
		print chr$("------- timings, 16-byte aligned, 100 byte string -------", 13, 10)
	endif

	REPEAT rct
		push eax
		cycles Src, szLen
	;	cycles Src, MbStrLen1
	;	cycles Src, MbStrLen2
	;	cycles Src, MbStrLen3
;		cycles Src, MbStrLen4a
	;	cycles Src, MbStrLen4aP4
	;	cycles Src, MbStrLen4aP42
	;	cycles Src, MbStrLen5
	;	cycles Src, AxStrLenMMX	; crashes
		cycles Src, AxStrLenSSE1
;		cycles Src, AxJJStrLen1
;		cycles Src, AxJJStrLen2
;		cycles Src, AxJJStrLen3
		cycles Src, AxJJStrLen4
		cycles Src, AxJJStrLen5
;		cycles Src, AxJJStrLen6
		if CrashIt and ShowLingoBang eq 0
			print "No result for Lingo's algo, it crashes", 13, 10
		elseif ShowLingoBang
			cycles Src, StrLenLingo, (unsafe)
		endif
		print chr$(13, 10)
	ENDM
	add esp, rct*4

if ShowShorts
	if CrashIt
		print chr$("------- timings, crash mode, 5 byte string -------", 13, 10)
	elseif MisAlign
		print chr$("------- timings, misaligned, 5 byte string -------", 13, 10)
	else
		print chr$("------- timings, 16-byte aligned, 5 byte string -------", 13, 10)
	endif

	shortstring equ offset src20		; try src14
	REPEAT rct
		push eax
		cycles shortstring, szLen
	;	cycles shortstring, MbStrLen1
	;	cycles shortstring, MbStrLen2
	;	cycles shortstring, MbStrLen3
;		cycles shortstring, MbStrLen4a
	;	cycles shortstring, MbStrLen4aP4
	;	cycles shortstring, MbStrLen4aP42
	;	cycles shortstring, MbStrLen5
	;	cycles shortstring, AxStrLenMMX	; crashes
		cycles shortstring, AxStrLenSSE1
;		cycles shortstring, AxJJStrLen1
;		cycles shortstring, AxJJStrLen2
;		cycles shortstring, AxJJStrLen3
		cycles shortstring, AxJJStrLen4
		cycles shortstring, AxJJStrLen5
;		cycles shortstring, AxJJStrLen6
		if CrashIt and ShowLingoBang eq 0
			print "No result for Lingo's algo, it crashes", 13, 10
		elseif ShowLingoBang
			cycles shortstring, StrLenLingo, (unsafe)
		endif
		print chr$(13, 10)
	ENDM
	add esp, rct*4
endif
	mov ebx, 100
	mov EspGlob, esp
	movd xmm0, ebx
	pshufd xmm0, xmm0, 0
	.Repeat
		push eax
		push Src
		mov ecx, 12345678
		call AxJJStrLen4
		.if ecx!=12345678
			pushad
			invoke MessageBox, 0, str$(ebx), chr$("Loop"), MB_OK
			popad
			.Break
		.endif
		dec ebx
	.Until Sign?
	mov esp, EspGlob
	movd ebx, xmm0
	.if ebx!=100
			invoke MessageBox, 0, str$(ebx), chr$("xmm"), MB_OK
	.endif
	invoke VirtualFree, vaPtr, 0, MEM_RELEASE
	inkey chr$("--- ok ---", 13)
	exit

a16
MbStrLen1_s:
MbStrLen1 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
;int 3
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	; nop	; one nop means align 16 for innermost loop but has no effect on Celeron
	push edx	; edx preserved because Masm32 szLen preserves it
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	sub eax, [esp+12]	; subtract original src pointer
	lea eax, [eax+edx-16]	; add scan index
	pop edx
	pop ecx
	ret 4
MbStrLen1 endp
MbStrLen1_endp:
a16
MbStrLen2_s:
MbStrLen2 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
	xtrabytes = 8+16
	mov eax, [esp+4]	; get the src pointer
	sub esp, xtrabytes
	mov [esp], ecx	; Mb ABI: ecx is safe ;-)
	mov [esp+4], edx	; edx preserved because Masm32 szLen preserves it
	movups [esp+8], xmm0
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	sub eax, [esp+4+xtrabytes]	; subtract original src pointer
	lea eax, [eax+edx-16]	; add scan index
	mov ecx, [esp]	; Mb ABI: ecx is safe ;-)
	mov edx, [esp+4]	; edx preserved because Masm32 szLen preserves it
	movups xmm0, [esp+8]
	add esp, xtrabytes
	ret 4
MbStrLen2 endp
MbStrLen2_endp:
a16
MbStrLen3_s:
MbStrLen3 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
	xtrabytes = 16
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	movdqu [esp], xmm0
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	sub eax, [esp+12+xtrabytes]	; subtract original src pointer
	lea eax, [eax+edx-16]	; add scan index
	movups xmm0, [esp]
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen3 endp
MbStrLen3_endp:

a16
MbStrLen4a_s:
MbStrLen4a proc ; src:DWORD	*** SSE2-safe version of 22.8.10, 80 bytes ***
xtrabytes	= 16
forP4	= 0
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	ife forP4
		movlps qword ptr [esp], xmm0
		movhps qword ptr [esp+8], xmm0
	else
		movdqu [esp], xmm0
	endif
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	push ecx
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
;	int 3			; OPT_Olly 2
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
		pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	ife forP4
		movlps xmm0, qword ptr [esp]
		movhps xmm0, qword ptr [esp+8]
	else
		lddqu xmm0, oword ptr [esp]
	endif
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen4a endp
MbStrLen4a_endp:

a16
MbStrLen4aP4_s:
MbStrLen4aP4 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
xtrabytes	= 16
forP4	= 1
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	ife forP4
		movsd qword ptr [esp], xmm0
		movhpd qword ptr [esp+8], xmm0
	else
;		movsd qword ptr [esp], xmm0	; not faster; [url=http://wikis.sun.com/display/BluePrints/Instruction+Selection]link[/url]
;		movhpd qword ptr [esp+8], xmm0
		movdqu [esp], xmm0
	endif
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	push ecx
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
		pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	ife forP4
		movlps xmm0, qword ptr [esp]
		movhps xmm0, qword ptr [esp+8]
	else
		lddqu xmm0, oword ptr [esp]
	endif
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen4aP4 endp
MbStrLen4aP4_endp:

a16
MbStrLen4aP42_s:
MbStrLen4aP42 proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
xtrabytes	= 16
forP4	= 1
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	ife forP4
		movlps qword ptr [esp], xmm0
		movhps qword ptr [esp+8], xmm0
	else
		movdqu [esp], xmm0
	endif
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	push ecx
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
		pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	ife forP4
		movlps xmm0, qword ptr [esp]
		movhps xmm0, qword ptr [esp+8]
	else
		movdqu xmm0, oword ptr [esp]	; SSE2
;		lddqu xmm0, oword ptr [esp]		; SSE3
	endif
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen4aP42 endp
MbStrLen4aP42_endp:

a16
MbStrLen4b_s:
MbStrLen4b proc ; src:DWORD	*** SSE2-safe version of 3.8.10, 59 bytes ***
	;int 3
	xtrabytes = 16
	mov eax, [esp+4]	; get the src pointer
	push ecx	; Mb ABI: ecx is safe ;-)
	push edx	; edx preserved because Masm32 szLen preserves it
	sub esp, xtrabytes
	if 0
	movlps qword ptr [esp], xmm0
	movhps qword ptr [esp+8], xmm0
	else
	movdqu [esp], xmm0
	endif
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
		push ecx
	and eax, -16	; align for use with SSE2
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
		pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	if 0
	movlps xmm0, qword ptr [esp]
	movhps xmm0, qword ptr [esp+8]
	else
	movups xmm0, [esp]
	endif
	add esp, xtrabytes
	pop edx
	pop ecx
	ret 4
MbStrLen4b endp
MbStrLen4b_endp:
a16
MbStrLen5_s:
MbStrLen5 proc uses ecx edx src:DWORD	; *** SSE2-safe version of 3.8.10, 59 bytes ***
LOCAL xmmbuffer[16]:BYTE
	if 1
	movlps qword ptr xmmbuffer, xmm0
	movhps qword ptr xmmbuffer+8, xmm0
	else
	movdqu [esp], xmm0
	endif
	mov eax, src	; get the src pointer
	lea ecx, [eax+16]	; save pointer to string, on par with eax after first loop
	and eax, -16	; align for use with SSE2
	push ecx
shiftOK:	xorps xmm0, xmm0	; zero xmm0 for finding zero bytes
@@:	pcmpeqb xmm0, [eax]	; ---- inner loop -----
	pmovmskb edx, xmm0	; set byte mask in edx
	add eax, 16	; len counter (best position here)
	test edx, edx
	jz @B
	cmp ecx, eax	; remainder from first "misaligned" read?
	jle @F
	sub ecx, eax	; get difference, and cancel "misalign flag"
	shr edx, cl	; shift invalid
	shl edx, cl	; bits out
	je shiftOK
@@:	bsf edx, edx	; bit scan for the index
	pop ecx
	sub eax, ecx	; subtract original src pointer
	add eax, edx	; add scan index
	if 1
	movlps xmm0, qword ptr xmmbuffer
	movhps xmm0, qword ptr xmmbuffer+8
	else
	movups xmm0, [esp]
	endif
	ret
MbStrLen5 endp
MbStrLen5_endp:





OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
align 16
db 12 dup (0CCh)
AxStrLenMMX_s:
AxStrLenMMX	proc STDCALL lpszStr:DWORD	; SSE safe, because MMX :), ECX safe :), trashed last FPU reg :)
	;int 3
	mov edx,[esp+4]
	@@:
	pxor mm7,mm7		; if carry out this from loop, then loop is slower
	pcmpeqb mm7,[edx]	; if you check this, don't forgot change count of dup to 9 (not 12)
	add edx,8
	pmovmskb eax,mm7
	test eax,eax
	jz @B
	bsf eax,eax
	sub edx,[esp+4]
	lea eax,[eax+edx-8]
	ret 4
AxStrLenMMX	endp
AxStrLenMMX_endp:
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
align 16
a16
AxStrLenSSE1_s:
db 7 dup (0)
AxStrLenSSE1	proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe :), fast with unaligned strings
;	int 3
	mov edx,[esp+4]
	mov eax,[esp+4]
	add esp,-14h
	movups [esp],xmm7
	mov [esp+16],ecx
	and edx,-10h
	mov ecx,0fh
	pxor xmm7,xmm7
	and ecx,eax
	jz @F
	pcmpeqb xmm7,[edx]
	add edx,10h
	pmovmskb eax,xmm7
	shr eax,cl
	bsf eax,eax
	jnz @ret
	pxor xmm7,xmm7	; Jochen, you can drink yourself a red wine promised to me, many thanks!
	@@:
	align 16
	@@:
	pcmpeqb xmm7,[edx]
	add edx,16
	pmovmskb eax,xmm7
	test eax,eax
	jz @B

	bsf eax,eax
	sub edx,[esp+4+16+4]
	lea eax,[eax+edx-10h]

	@ret:
	movups xmm7,[esp]
	mov ecx,[esp+16]
	add esp,14h
	ret 4

AxStrLenSSE1	endp
AxStrLenSSE1_endp:

a16
AxJJStrLen1_s:
	retn 0		; one byte means align 4 for inner loop
AxJJStrLen1 proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe :), fast with unaligned strings
	push ecx
	mov edx, [esp+8]
	mov ecx, edx	; after the add esp saves 2 cycles on P4 - check Celeron
	add esp, -14h	; -10h same cycles on P4 but tests on Celeron needed.
	and edx, -10h	; align the string to 16 bytes for SSE2
	movups [esp], xmm0	; save a precious xmm register
	sub ecx, edx
	xorps xmm0, xmm0	; thanks for the correction, Alex
	jz @L2
	pcmpeqb xmm0, [edx]	; there may be nullbytes before the real string
	pmovmskb eax, xmm0
	shr eax, cl	; shift their bits out
	bsf eax, eax
	jnz @ret
	xorps xmm0, xmm0
@@:	add edx, 16
@L2:	pcmpeqb xmm0, [edx]
	pmovmskb eax, xmm0
	test eax, eax
	jz @B

	bsf eax, eax
	sub edx, [esp+4+16+4+4]
	add eax, edx

@ret:	movups xmm0, [esp]
	add esp, 14h
	pop ecx
	ret 4

AxJJStrLen1 endp
AxJJStrLen1_endp:

a16
AxJJStrLen2_s:
	retn 0		; one byte means align 4 for inner loop
AxJJStrLen2 proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe :), fast with unaligned strings
	push ecx
	mov edx, [esp+8]
	add esp, -10h	; -10h same cycles on P4 but tests on Celeron needed.
	mov ecx, edx	; after the add esp saves 2 cycles on P4 - check Celeron
	and edx, -10h	; align the string to 16 bytes for SSE2
	movups [esp], xmm0	; save a precious xmm register
	sub ecx, edx
	xorps xmm0, xmm0	; thanks for the correction, Alex
	jz @L2
	pcmpeqb xmm0, [edx]	; there may be nullbytes before the real string
	pmovmskb eax, xmm0
	shr eax, cl	; shift their bits out
	bsf eax, eax
	jnz @ret
	xorps xmm0, xmm0
@@:	add edx, 16
@L2:	pcmpeqb xmm0, [edx]
	pmovmskb eax, xmm0
	test eax, eax
	jz @B

	bsf eax, eax
	sub edx, [esp+4+16+4]
	add eax, edx

@ret:	movups xmm0, [esp]
	add esp, 10h
	pop ecx
	ret 4

AxJJStrLen2 endp
AxJJStrLen2_endp:

.data?
align 16
xmmsave	dq ?, ?
.code

a16
AxJJStrLen3_s:
	retn 0		; one byte means align 4 for inner loop
AxJJStrLen3 proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe :), fast with unaligned strings
	push ecx
	mov edx, [esp+8]
	mov ecx, edx	; after the add esp saves 2 cycles on P4 - check Celeron
	and edx, -10h	; align the string to 16 bytes for SSE2
	movdqa oword ptr xmmsave, xmm0	; save a precious xmm register
	sub ecx, edx
	xorps xmm0, xmm0	; thanks for the correction, Alex
	jz @L2
	pcmpeqb xmm0, [edx]	; there may be nullbytes before the real string
	pmovmskb eax, xmm0
	shr eax, cl	; shift their bits out
	bsf eax, eax
	jnz @ret
	xorps xmm0, xmm0
;	align 4 done above
@@:	add edx, 16
@L2:	pcmpeqb xmm0, [edx]
	pmovmskb eax, xmm0
	test eax, eax
	jz @B
	bsf eax, eax
	sub edx, [esp+4+4]
	add eax, edx
@ret:	movdqa xmm0, oword ptr xmmsave	; restore a precious xmm register
	pop ecx
	ret 4

AxJJStrLen3 endp
AxJJStrLen3_endp:

a16
AxJJStrLen4_s:
AxJJStrLen4 proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe :), fast with unaligned strings
	push ecx
	Extra = 32
	mov edx, [esp+8]	; get pointer to source string
	add esp, -Extra	; create a slot on stack
	lea ecx, [esp+Extra-16]	; find a safe slot in Extrabytes
	and ecx, -16	; align it by 16 for movaps
	mov [esp], ecx	; save its position
	movaps [ecx], xmm0	; save a precious xmm register
	mov ecx, edx	; after the add esp saves 2 cycles on P4 - check Celeron
	and edx, -10h	; align the string to 16 bytes for SSE2
	sub ecx, edx
	xorps xmm0, xmm0	; thanks for the correction, Alex
	jz @L2
	pcmpeqb xmm0, [edx]	; there may be nullbytes before the real string
	pmovmskb eax, xmm0
	shr eax, cl	; shift their bits out
	bsf eax, eax
	jnz @ret
	xorps xmm0, xmm0
@@:	add edx, 16
@L2:	pcmpeqb xmm0, [edx]
	pmovmskb eax, xmm0
	test eax, eax
	jz @B

	bsf eax, eax
	sub edx, [esp+4+Extra+4]
	add eax, edx

@ret:	mov ecx, [esp]
	movaps xmm0, [ecx]
	add esp, Extra
	pop ecx
	ret 4

AxJJStrLen4 endp
AxJJStrLen4_endp:

a16
AxJJStrLen5_s:
AxJJStrLen5 proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe, fast with unaligned strings
	Extra = 36	; 32 would trash ecx
	mov edx, [esp+4]	; credits for this algo to [url=http://www.masm32.com/board/index.php?topic=14626.msg118322#msg118322]Antaryi[/url]
	add esp, -Extra
	mov [esp+4], ecx
	lea ecx, [esp+Extra-16]
	and ecx, -16
	mov [esp], ecx
	movdqa [ecx], xmm0	; save a precious xmm register
	mov ecx, edx	; after the add esp saves 2 cycles on P4 - check Celeron
	and edx, -16	; align the string to 16 bytes for SSE2
	sub ecx, edx
	xorps xmm0, xmm0	; thanks for the correction, Alex
	jz @L2
	pcmpeqb xmm0, [edx]	; there may be nullbytes before the real string
	pmovmskb eax, xmm0
	shr eax, cl	; shift their bits out
	bsf eax, eax
	jnz @ret
	xorps xmm0, xmm0
@@:	add edx, 16
@L2:	pcmpeqb xmm0, [edx]
	pmovmskb eax, xmm0
	test eax, eax
	jz @B
	bsf eax, eax
	sub edx, [esp+4+Extra]
	add eax, edx
@ret:	mov ecx, [esp]
	movdqa xmm0, [ecx]
	mov ecx, [esp+4]
	add esp, Extra
	ret 4

AxJJStrLen5 endp
AxJJStrLen5_endp:

a16
AxJJStrLen6_s:
AxJJStrLen6 proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe, fast with unaligned strings
	Extra = 40
	mov edx, [esp+4]	; credits for this algo to [url=http://www.masm32.com/board/index.php?topic=14626.msg118322#msg118322]Antaryi[/url]
	add esp, -Extra
	mov [esp+4], ecx
	lea ecx, [esp+Extra-16]
	and ecx, -16
	mov [esp], ecx
	movaps [ecx], xmm0	; save a precious xmm register
	mov ecx, edx	; after the add esp saves 2 cycles on P4 - check Celeron
	and edx, -16	; align the string to 16 bytes for SSE2
	sub ecx, edx
	xorps xmm0, xmm0	; thanks for the correction, Alex
	jz @L2
	pcmpeqb xmm0, [edx]	; there may be nullbytes before the real string
	pmovmskb eax, xmm0
	shr eax, cl	; shift their bits out
;	bsf eax, eax
	jnz @ret1
	xorps xmm0, xmm0
@@:	add edx, 16
@L2:	pcmpeqb xmm0, [edx]
	pmovmskb eax, xmm0
	test eax, eax
	jz @B
	bsf eax, eax
	sub edx, [esp+4+Extra]
	add eax, edx
@ret:	mov ecx, [esp]
	movaps xmm0, [ecx]
	mov ecx, [esp+4]
	add esp, Extra
	ret 4
@ret1:	bsf eax, eax	; good on P4 but disastrous on Celeron M
	mov ecx, [esp]
	movaps xmm0, [ecx]
	mov ecx, [esp+4]
	add esp, Extra
	ret 4

AxJJStrLen6 endp
AxJJStrLen6_endp:

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
a16
StrLenLingo_s:
db	  5 Dup(0)
StrLenLingo	proc	lpszStr:DWORD
	pop				edx
	pop				eax
	movdqu		xmm1, [eax]
	mov				edx,     eax
	and				eax,     -16
	pxor			xmm0, xmm0
	pcmpeqb	xmm1, xmm0
	pmovmskb	ecx,		xmm1	
	test				ecx,		ecx
	jne				ExA
@@:
	pcmpeqb	xmm0,	[eax+16]
	pcmpeqb	xmm1,	[eax+32]
	por				xmm1, xmm0		
	add				eax,		32		
	pmovmskb	ecx,		xmm1	
	test				ecx,		ecx
	jz					@b
	shl				ecx,		16	
	sub				eax,		edx
	pmovmskb	edx,		xmm0
	add				ecx,		edx	
	bsf				ecx,		ecx
	lea				eax,		[eax+ecx-16]
	jmp				dword	ptr [esp-2*4] 
ExA:
	bsf				eax,	ecx
	mov edx, [esp-8]		; added by JJ (still unsafe but for testing it's ok)
	jmp				edx
StrLenLingo	endp
StrLenLingo_endp:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4
StrLen_s:
StrLen proc item:DWORD

    mov     eax, [esp+4]            ; get pointer to string
    lea     edx, [eax+3]            ; pointer+3 used in the end
    push    ebp
    push    edi
    mov     ebp, 80808080h

  @@:     
  REPEAT 3
    mov     edi, [eax]              ; read first 4 bytes
    add     eax, 4                  ; increment pointer
    lea     ecx, [edi-01010101h]    ; subtract 1 from each byte
    not     edi                     ; invert all bytes
    and     ecx, edi                ; and these two
    and     ecx, ebp
    jnz     nxt
  ENDM

    mov     edi, [eax]              ; read first 4 bytes
    add     eax, 4                  ; 4 increment DWORD pointer
    lea     ecx, [edi-01010101h]    ; subtract 1 from each byte
    not     edi                     ; invert all bytes
    and     ecx, edi                ; and these two
    and     ecx, ebp
    jz      @B                      ; no zero bytes, continue loop

  nxt:
    test    ecx, 00008080h          ; test first two bytes
    jnz     @F
    shr     ecx, 16                 ; not in the first 2 bytes
    add     eax, 2
  @@:
    shl     cl, 1                   ; use carry flag to avoid branch
    sbb     eax, edx                ; compute length
    pop     edi
    pop     ebp
    ret     4
StrLen endp
StrLen_endp:
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 



ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:
OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
OPT_Res	0

Celeron timings
------- timings, misaligned, 100 byte string -------
132     cycles for szLen
34      cycles for AxStrLenSSE1
33      cycles for AxJJStrLen4
33      cycles for AxJJStrLen5

30      cycles for szLen
18      cycles for AxStrLenSSE1
17      cycles for AxJJStrLen4
17      cycles for AxJJStrLen5

P4 timings
Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)
97      code size for AxStrLenSSE1      104     total bytes for AxStrLenSSE1
77      code size for AxJJStrLen1       78      total bytes for AxJJStrLen1
77      code size for AxJJStrLen2       78      total bytes for AxJJStrLen2
79      code size for AxJJStrLen3       80      total bytes for AxJJStrLen3
88      code size for AxJJStrLen4       88      total bytes for AxJJStrLen4
96      code size for AxJJStrLen5       96      total bytes for AxJJStrLen5
------- timings, 16-byte aligned, 100 byte string -------
64      AxStrLenSSE1
62      AxJJStrLen3 (not thread-safe)
64      AxJJStrLen4
62      AxJJStrLen5
------- timings, misaligned, 100 byte string -------
62      AxStrLenSSE1
65      AxJJStrLen3
69      AxJJStrLen4
67      AxJJStrLen5

Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3) - with @ret1 branch
------- timings, 16-byte aligned, 100 byte string -------
252     szLen
61      AxStrLenSSE1
69      AxJJStrLen4
62      AxJJStrLen5
------- timings, misaligned, 100 byte string -------
91      szLen
29      AxStrLenSSE1
28      AxJJStrLen4
28      AxJJStrLen5